#ifndef ALIVEVIDEO
#define ALIVEVIDEO

#include <Inventor/SbLinear.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/SoXtRenderArea.h>
#include <Inventor/nodes/SoCallback.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include "packet.h"
#include <Inventor/SbPList.h>
#include <Inventor/SbLinear.h>
class VideoMatte;

#define COGW 128.0
#define COGH 120.0

class AliveVideo :public AliveCamera{
    public:
    int connection;
    int bbox[4];	/* current bbox (vis) */
    int delta[4];	/* deltas in left,bottom,right,top sides */
    int cxy[2];		/* center of mass xy (vis) */
    int rhxy[2];	/* right hand xy (vis) */
    int lhxy[2];	/* left hand xy (vis) */
    int hxy[2];		/* head xy (vis) */
    int oldcxy[2];		/* center of mass xy (vis) */
    int oldrhxy[2];	/* right hand xy (vis) */
    int oldlhxy[2];	/* left hand xy (vis) */
    int oldhxy[2];		/* head xy (vis) */
    
    SbVec3f cm;		/* center of mass xyz (world) */
    SbVec3f head;	/* head xyz (world) */
    SbVec3f rhand;	/* rhand xyz (world) */
    SbVec3f lhand;	/* lhand xyz (world) */
    SbVec3f bbox3d[2];	/* bounding box (bottom left, top right) */
    VideoMatte *videoMatte;
   
    SbPList markerXF;	/* marker transforms */
    data_packet response;
    int firstTime;
    int showBodyMarkers;
    int showVideoMatte;
    
    AliveVideo(SoPerspectiveCamera *cam, SoXtRenderArea *renderArea, 
	SbVec3f camPos,SbMatrix camO,float vscale);
    void printDataFromCognex();
    int  readDataFromCognex();
    void openConnection();
    void closeConnection();
    void setShowBodyMarkers(int yn, SoSeparator *where);
    void setShowVideoMatte(int yn, SoSeparator *where);
    void buildPersonTracker(SoSeparator *theMarkers);
    void newPerson();
    void smooth();
    void projectPersonInto3DWorld();
    int  getNewPosition(SbVec3f *cm1, SbVec3f *lh,SbVec3f *rh, SbVec3f *hd);
    
};

#endif
