#include <sys/time.h>
#include "TimeStat.h"
#include <stdio.h>
 
Timestat::Timestat(char *pn,float ap)
{
  pname = pn;
  avgingPeriod = ap;
  period = 0;
  totalTime = 0;
  avgTime = 0;
  starttime.tv_sec = 0;
  starttime.tv_usec = 0;
}

void Timestat::init()
{ 
  period = 0;
  totalTime = 0;
  avgTime = 0;
  starttime.tv_sec = 0;
  starttime.tv_usec = 0;
}

void Timestat::startTime()
{
  gettimeofday(&starttime, 0);
}

void Timestat::endTime()
{
  if(starttime.tv_sec){
    gettimeofday(&endtime, 0);
    totalTime += (endtime.tv_sec - starttime.tv_sec) +
	((double)(endtime.tv_usec - starttime.tv_usec))/1.0e6;
    period++;
    if(period == avgingPeriod){
	avg();
	print();
	init();
    }
  }
}

void Timestat::avg()
{
  avgTime = totalTime/(float)period;
}

void Timestat::print()
{
  printf("avg time for %s is %f\n",pname,avgTime);
}
