
#include <matrix.h>
#include <stdio.h>

matrix_type *loadMatrix(filename)
     char *filename;
{
  char lines[100][1024];
  int nlines = 0;
  
  FILE *stream = NULL;

  if (filename)
    stream = fopen(filename,"r");
  else
    stream=stdin;

  if (stream != (FILE*) NULL) {
    
    while (fgets(lines[nlines],1024,stream)) {
      nlines ++;
    }  
    
    {
      matrix_type *test = make_matrix_type(5,nlines,"test");
      int i;
      for (i=0;i<nlines;i++) 
	{
	  sscanf(lines[i],"%f%f%f%f%f",
		 &MREF(test, i,0),
		 &MREF(test, i,1),
		 &MREF(test, i,2),
		 &MREF(test, i,3),
		 &MREF(test, i,4));
	}
      
#ifdef VEBOSE
      matrix_print(stdout,test);
#endif
      return test;
    }
  } else 
    return (matrix_type *) NULL;
}

main(argc,argv) 
     int argc;
     char *argv[];
{
  matrix_type *test;
  matrix_type *P;
  
				/* load test.dat */
  if (argc > 1) 
    test = loadMatrix(argv[1]);
  else
    test = loadMatrix(NULL);

  printf("maxerr is: %g\n",do_calibration(matrix_height(test),test,&P));
  matrix_print(stdout,P);
}


