% script to do calibration
load test.dat;
% test = perturb(test,.10);
test = nmatrix(test,1,1);
a = buildMatrix(test);
% disp('Rank of Matrix A')
% rank(a)

c = extractC(a);
d = extractD(a);
% this does a common operation
ctci = (c' * c)^(-1);

% find eigen-values to arrive at z
ea = (d'*d - d'*c*(ctci*c'*d));
[x,ev] =eig(ea);
evs = sort(ev);
[y,j] = min(evs(3,:));
z = x(:,j);

% now find y
y = - ctci*c'*d*z;

% P is the camera matrix
P = [y(1:4)';y(5:8)';z(1:3)' y(9)];
disp('The computed camera matrix is ')
disp(P)

% sanity check to make sure matrix does what it claims
for i=1:length(test)
	err = testCalib(P,test(i,1:3));
	er2 = err(1:2)' - test(i,4:5);
	mag(i) = sum(er2 .* er2);
end
maxerr = max(mag(i));
maxerr

% now calculate parameters
calcParameters(P,1,-1,-1);


